//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Tue Jan 12 09:03:35 PST 1999
// Last Modified: Tue Jan 12 09:03:35 PST 1999
// Filename:      Keyboard.h
// Syntax:        C++ 
// $Smake:        g++ -O3 -g -c %f && rm %b.o
//
// Reference:     http://cowf.cc.utexas.edu/~apoc/programs/c/kbhit.c
//


#ifndef _KEYBOARDINPUT_UNIX_H_INCLUDED
#define _KEYBOARDINPUT_UNIX_H_INCLUDED

#ifndef VISUAL

#include <termio.h>

class KeyboardInput_unix {
   public:
                KeyboardInput_unix      (void);
               ~KeyboardInput_unix      ();

      int       hit                     (void);
      int       getch                   (void);
      void      newset                  (void);
      void      oldset                  (void);
      void      reset                   (void);

   protected:
      int                    termioset;
      static int             classCount;
      static struct termio   current_io;
      static struct termio   original_io;

   private:
      void      initialize               (void);
      void      deinitialize             (void);
 

};

#endif  // VISUAL

#endif  // _KEYBOARDINPUT_UNIX_H_INCLUDED



